picard.util

## Class MetricsDoclet

- java.lang.Object
- - com.sun.tools.doclets.standard.Standard
  - - picard.util.MetricsDoclet

-     public class MetricsDoclet
      extends com.sun.tools.doclets.standard.Standard

  Doclet for use with JavaDoc that will find all classes extending MetricBase and output information about the metrics definitions that go along with the classes.

  Takes a single parameter (-f file) to tell it where to output the resulting documentation file in HTML format.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MetricsDoclet()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static String` | `firstSentence(com.sun.javadoc.Doc doc)` Takes a Doc object and uses the firstSentenceTags() to recreate the first sentence text.
    `protected static PrintStream` | `getOutput(com.sun.javadoc.RootDoc root)` Gets the file output parameter from the RootDoc and then opens an PrintStream to write to the file.
    `protected static boolean` | `isMetricsClass(com.sun.javadoc.ClassDoc doc)` Checks to see if the class extends MetricBase using only the JavaDoc metadata provided about the class.
    `static boolean` | `start(com.sun.javadoc.RootDoc root)` Entry point called by the javadoc command line tool.

    - ### Methods inherited from class com.sun.tools.doclets.standard.Standard

      `languageVersion, optionLength, validOptions`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MetricsDoclet

          public MetricsDoclet()

  - ### Method Detail

    - #### start

          public static boolean start(com.sun.javadoc.RootDoc root)

      Entry point called by the javadoc command line tool. Loops over all the classes identifying metrics classes and then produces some basic information about each in a single HTML file.
      Parameters:
        `root` - the root of the javadoc object hierarchy
      Returns:
        true if completed successfully, false otherwise

    - #### isMetricsClass

          protected static boolean isMetricsClass(com.sun.javadoc.ClassDoc doc)

      Checks to see if the class extends MetricBase using only the JavaDoc metadata provided about the class.
      Parameters:
        `doc` - the ClassDoc representing the class to be tested
      Returns:
        true if the class is a metrics class, false otherwise

    - #### getOutput

          protected static PrintStream getOutput(com.sun.javadoc.RootDoc root)

      Gets the file output parameter from the RootDoc and then opens an PrintStream to write to the file.

    - #### firstSentence

          protected static String firstSentence(com.sun.javadoc.Doc doc)

      Takes a Doc object and uses the firstSentenceTags() to recreate the first sentence text.